/* (C) 1997 Duddie / Vision Thing Software Group */

/* MSCDEX - handling routines... works fine under windows95 */


/* REMOVE COMMENT BELOW TO MAKE IT WORK IN LONE MODE */
//#define _TESTMODE
#include <stdio.h>
#include <dpmi.h>
#include "cdmac.h"
typedef unsigned char u_char;

typedef struct
{
 u_char size;
 u_char suc;
 u_char cmd;
 u_char stat;
 u_char reserved[9];
} REQHDR;

typedef struct
{
 REQHDR myRH;
 u_char media;
 short TAs;
 short TAo;
 short tb;
 short ss;
 short p1;
 short p2;
} CTLIO;

typedef struct
{
 REQHDR myRH;
 u_char amode;
 short TAs;
 short TAo;
 short count;
 short ss1;
 short ss2;
 u_char dmode;
 u_char interl;
 u_char inters;
} READL;

typedef struct
{
 REQHDR myRH;
 u_char media;
 short  ss1;
 short  ss2;
 short  count1;
 short  count2;
} PLAYREQ;

typedef struct
{
 u_char code;
 u_char lt;
 u_char ht;
 u_char leadout[4]; 
} DISCINFO;

typedef struct
{
 u_char code;
 u_char tn;
 u_char t[4];
 u_char control;
} TNOINFO;

typedef struct
{
 u_char code;
} EJECTDISC;

/*typedef struct
{
 const u_char code;
 u_char control;
 u_char tno;
 u_char point;
 u_char ;
 u_char ;
 u_char ;
 u_char ;
 u_char ;
 u_char ;
 u_char ;
 u_char ;
 u_char ;
} QINFO;*/

PLAYREQ myPR;
CTLIO myCTL;
READL myRL;
DISCINFO myDI;
EJECTDISC myED;
TNOINFO myTI;
//QINFO myQI = {12};

u_char transferB[16384];

int dCTLsel;
int dCTLseg;
int dDIsel;
int dDIseg;
int dPRsel;
int dPRseg;
int dTBsel;
int dTBseg;
int dTIsel;
int dTIseg;

int dCD;

long dSectorEnd;

long dcdInit(void)
{
 __dpmi_regs r;

 dCTLseg = __dpmi_allocate_dos_memory( 2048/4, &dCTLsel);
 dDIseg = __dpmi_allocate_dos_memory( (sizeof(DISCINFO)+15)/4, &dDIsel);
 dPRseg = __dpmi_allocate_dos_memory( (sizeof(PLAYREQ)+15)/4, &dPRsel);
 dTBseg = __dpmi_allocate_dos_memory( 4096/4, &dTBsel);

 r.x.ax = 0x1500;
 r.x.bx = 0;
 __dpmi_int(0x2f, &r);
 dCD = r.x.cx;
 return (r.x.bx<<16)|r.x.cx;
}

int dcdGetTOC(void)
{
 __dpmi_regs r;
 r.x.ax = 0x1505;
 r.x.es = dTBseg;
 r.x.bx = 1;
 r.x.cx = dCD;
 r.x.dx = 0;
 __dpmi_int(0x2f, &r);
 dosmemget(dTBseg*16, 2048, &transferB);
 return r.x.ax;
}

void dcdRemove(void)
{
 __dpmi_free_dos_memory(dCTLsel);
 __dpmi_free_dos_memory(dDIsel);
 __dpmi_free_dos_memory(dPRsel);
 __dpmi_free_dos_memory(dTBsel);
}

int dcdGetTN(char *result)
{
 __dpmi_regs r;
 int i;

 myDI.code = 10;
 dosmemput(&myDI, sizeof(DISCINFO), dDIseg*16);

 myCTL.myRH.size = sizeof(REQHDR);
 myCTL.myRH.cmd = 3;
 myCTL.myRH.suc = 0;
 myCTL.TAo = dDIseg;
 myCTL.TAs = 0;
 myCTL.ss = 0;
 myCTL.media = 0;

 dosmemput(&myDI, sizeof(DISCINFO), dDIseg*16);
 dosmemput(&myCTL, sizeof(CTLIO), dCTLseg * 16);

 r.x.ax = 0x1510;
 r.x.es = dCTLseg;
 r.x.bx = 0;
 r.x.cx = dCD;
 __dpmi_int(0x2f, &r);

 dosmemget(dCTLseg*16, sizeof(CTLIO), &myCTL);
 dosmemget(dDIseg*16, sizeof(DISCINFO), &myDI);

 result[0]=myDI.lt;
 result[1]=myDI.ht;
 for (i=0;i<4;i++) result[2+i] = myDI.leadout[3-i];
 dSectorEnd = (myDI.leadout[2]*60+myDI.leadout[1])*75+myDI.leadout[0]-150;
 return myCTL.myRH.stat;

/* printf("2f returned: %d,%d\n", myDI.lt, myDI.ht);
 printf("Error code: %02x", myCTL.myRH.stat);*/
}

int dcdGetTD(int nr, char *result)
{
 __dpmi_regs r;

 myTI.code = 11;
 myTI.tn = nr;

 myCTL.myRH.size = sizeof(REQHDR);
 myCTL.myRH.cmd = 3;
 myCTL.myRH.suc = 0;
 myCTL.TAo = dDIseg;
 myCTL.TAs = 0;
 myCTL.ss = 0;
 myCTL.media = 0;

 dosmemput(&myTI, sizeof(TNOINFO), dDIseg*16);
 dosmemput(&myCTL, sizeof(CTLIO), dCTLseg * 16);

 r.x.ax = 0x1510;
 r.x.es = dCTLseg;
 r.x.bx = 0;
 r.x.cx = dCD;
 __dpmi_int(0x2f, &r);

 dosmemget(dCTLseg*16, sizeof(CTLIO), &myCTL);
 dosmemget(dDIseg*16, sizeof(TNOINFO), &myTI);

 result[0] = myTI.t[3];
 result[1] = myTI.t[2];
 result[2] = myTI.t[1];
 result[3] = myTI.t[0];
 return myCTL.myRH.stat;

/* printf("2f returned: %d,%d,%d,%d\n", myTI.t[0], myTI.t[1], myTI.t[2], myTI.t[3]);
  printf("Error code: %02x", myCTL.myRH.stat);*/
}
int dcdPlay(char *param)
{
 __dpmi_regs r;
 long sector;
 long count;

 sector = (param[0]*60+param[1])*75+param[2]-150;
 count = dSectorEnd - sector;
 myPR.myRH.size = sizeof(REQHDR);
 myPR.myRH.cmd = 132;
 myPR.myRH.suc = 0;
 myPR.ss2 = sector/0x10000;
 myPR.ss1 = sector&0xffff;
 myPR.count2 = count/0x10000;
 myPR.count1 = count&0xffff;
 myPR.media = 0;

 dosmemput(&myPR, sizeof(PLAYREQ), dPRseg*16);

 r.x.ax = 0x1510;
 r.x.es = dPRseg;
 r.x.bx = 0;
 r.x.cx = dCD;
 __dpmi_int(0x2f, &r);

 dosmemget(dPRseg*16, sizeof(PLAYREQ), &myPR);
// printf("Error code: %02x", myPR.myRH.stat);
 return myPR.myRH.stat;
}





int dcdReadLong(char *param)
{
 __dpmi_regs r;
 long sector;
 int min,sec,fra;

 min = param[0];
 sec = param[1];
 fra = param[2];
 sec -= 2;
 if (sec<0) 
  {
   sec+=60;
   min--;
  }

sector = (min*60+sec)*75+fra;
// printf("%8x\n",sector);
// sector = (min<<16)|(sec<<8)|fra;

 myRL.myRH.size = sizeof(REQHDR);
 myRL.myRH.cmd = 128;
 myRL.myRH.suc = 0;
// myRL.ss1 = (param[0]<<8)|param[1];
// myRL.ss2 = (param[2])|0;
/*
 myRL.ss2 = min;
 myRL.ss1 = (sec<<8)+fra;
 myRL.count = 1;
 myRL.amode = 0;
 myRL.dmode = 0;
 myRL.interl = 0;
 myRL.inters = 1;
 myRL.TAo = dTBseg;
 myRL.TAs = 0;
 dosmemput(&myRL, sizeof(READL), dCTLseg*16);

 r.x.ax = 0x1510;
 r.x.es = dCTLseg;
 r.x.bx = 0;
 r.x.cx = dCD;
 __dpmi_int(0x2f, &r);
*/
 r.x.ax = 0x1508;
 r.x.es = dTBseg;
 r.x.bx = 0;
 r.x.cx = dCD;
 r.x.dx = 1;
 r.x.si = sector>>16;
 r.x.di = sector & 0xffff;
 __dpmi_int(0x2f, &r);
// dosmemget(dCTLseg*16, sizeof(READL), &myRL);
 dosmemget(dTBseg*16, 2048, transferB);
// if(myRL.myRH.stat) printf("Error code: %02x", myRL.myRH.stat);
 return 0; //myRL.myRH.stat;
}





int dcdStop(void)
{
 __dpmi_regs r;

 myPR.myRH.size = sizeof(REQHDR);
 myPR.myRH.cmd = 133;
 myPR.myRH.suc = 0;

 dosmemput(&myPR, sizeof(PLAYREQ), dPRseg*16);

 r.x.ax = 0x1510;
 r.x.es = dPRseg;
 r.x.bx = 0;
 r.x.cx = dCD;
 __dpmi_int(0x2f, &r);

 dosmemget(dPRseg*16, sizeof(PLAYREQ), &myPR);
// printf("Error code: %02x", myPR.myRH.stat);
 return myPR.myRH.stat;
}
#ifdef _TESTMODE
void main(void)
{
 FILE *out;
 int i, res, j,k,m;
 char resultN[6];
 char result[4];
 char param[4];
 dcdInit();
 dcdGetTN(resultN);
 printf("total ");
 for (j=0;j<4;j++) printf("%d ",resultN[j+2]);
 printf("\n");
 for (i=0;i<= resultN[1];i++)
  {
   dcdGetTD(i, result);
   printf("track %d: ",i);
   for (j=0;j<4;j++) printf("%d ",result[j]);
   printf("\n");
  }

out = fopen("txt","w");
i=0;
for (j=0;j<6;j++)
for (k=0;k<75;k++)
{
 param[0]=0;//itob(i);
 param[1]=j;//itob(j);
 param[2]=k;//itob(k);
// dcdPlay(param);
// while(!kbhit());
// if(! dcdReadLong(param))
 for(m=0;m<8;m++)
  if(!dcdReadLong(param)) break;

//  printf("%d:%d:%d\n",i,j,k);
  fprintf(out,"%d:%d:%d\n",i,j,k);
  if(!strncmp("CD001",transferB+1,5)) printf("CD001 found at: %d:%d:%d\n",i,j,k);
  for(m=0;m<2048;m++) if(transferB[m]<32 || transferB[m]>127) transferB[m]=' ';
  fprintf(out,"%s\n",transferB);

}
 fclose (out);
 dcdRemove();
}
#endif