/* (C) 1997 Duddie / Vision Thing Software Group */

/* BASED ON DISASEMBLER FOR N64 WRITTEN BY HIMBEEREIS IN DELPHI*/

#include <stdio.h>
#include "globals.h"
#include "texts.h"

int	 reg_mode[32] =
       {5,5,5,5,-1,-1,-1,-1,
	5,5,5,5,5,-1,5,-1,
	5,5,5,5,-1,-1,-1,-1,
	-1,-1,-1,-1,-1,-1,-1,-1};

int    nem_mode[64] =
      {0,1,2,2,8,8,5,5,
       4,4,4,4,4,4,4,10,
       20,20,20,-1,4,4,5,5,
       4,4,4,4,-1,-1,-1,-1,
       4,4,4,4,4,4,4,4,
       4,4,4,4,4,4,4,0,
       4,4,4,-1,4,4,4,4,
       4,4,4,-1,4,4,4,4};

int    snem_mode[64] =
	{7,-1,7,7,3,-1,3,3,
	 8,8,-1,-1,0,0,-1,0,
	 11,12,11,12,3,-1,3,3,
	 6,6,6,6,6,6,6,6,
	 3,3,3,3,3,3,3,3,
	 -1,-1,3,3,3,3,3,3,
	 6,6,6,6,6,-1,6,-1,
	 7,-1,7,7,7,-1,7,7};

char disBuf[256];

void disasmLine(unsigned long addrD)
{
unsigned long buf;
unsigned long imedU;
signed long imedS;
unsigned int rt, rs,rd,sa,func;
unsigned int op;
unsigned long addrR, addrPref;
unsigned long Jaddr, Baddr;

addrPref = (addrD >> 28) & 0xf;
addrR=addrD & 0xfffffff;
if ((addrPref==0 || addrPref==8 || addrPref==0xA) && addrR < Meg8)
 {
  addrR &= 0x1fffff;
  buf = psxML[addrR/4];
 }
else if (addrD>=0xbfc00000 && addrD<0xbfc80000)
 {
  addrR &= 0x7ffff;
  buf = psxRL[addrR/4];
 }
else
 {
  sprintf(disBuf, "%08x NO ACCESS", addrD);
  return;
 }

op = (buf >> 26) & 0x3f;
imedU = buf & 0x0000ffff;
imedS=imedU;
if (imedU > 0x7fff) imedS = imedU |0xffff0000;
rt = (buf >> 16) & 0x1f;
rs = (buf >> 21) & 0x1f;
rd = (buf >> 11) & 0x1f;
sa = (buf >> 6) & 0x1f;
func = buf & 0x3f;

Baddr = (imedS << 2) + addrD + 4;
Jaddr = ((buf & 0x03ffffff )<< 2) | (addrD&0xf0000000);

if (!buf)
 sprintf(disBuf, "%08x %08x nop", addrD, buf);
else
 switch (nem_mode[op])
  {
   case 20:
        if (rs&0x10)
         sprintf(disBuf, "%08x %08x COP%d  func. %8x", addrD, buf, op&3 , buf&0x1ffffff);
        else
         sprintf(disBuf, "%08x %08x %s%d  %s,%s", addrD, buf, copNem[rs], op&3 , regName[rt], copReg[rd]);
	break;
   case 2:
	sprintf(disBuf, "%08x %08x %-5s 0x%08x", addrD, buf, nem[op],Jaddr );
	break;
   case 5: /* BRANCHES */
	sprintf(disBuf, "%08x %08x %-5s %s,0x%08x", addrD, buf, nem[op], regName[rs], Baddr);
	break;
   case 8: // *BRANCHES*
	sprintf(disBuf, "%08x %08x %-5s %s,%s,0x%08x", addrD, buf, nem[op], regName[rt], regName[rs], Baddr);
	break;
   case 4:
	sprintf(disBuf, "%08x %08x %-5s %s,%s,0x%04x", addrD, buf, nem[op], regName[rt], regName[rs], imedU);
	break;
   case 10:
	sprintf(disBuf, "%08x %08x %-5s %s,0x%04x", addrD, buf, nem[op], regName[rt], imedU);
	break;
   case 1:
	if (reg_mode[rt]==5)
	{
	 sprintf(disBuf, "%08x %08x %-5s %s,0x%08x", addrD, buf, rnem[rt],  regName[rs], Baddr);
	}
	else
	{
	 sprintf(disBuf, "%08x %08x %-5s 0x%08x", addrD, buf, "DD",buf);
	}
	break;
   case 0:
	switch (snem_mode[func]) 
	 {

	   case 0:
		sprintf(disBuf, "%08x %08x %-5s", addrD, buf, snem[func]);
		break;
	   case 9:
		sprintf(disBuf, "%08x %08x %-5s", addrD, buf, snem[func]);
		break;
	   case 8:
		sprintf(disBuf, "%08x %08x %-5s %s", addrD, buf, snem[func],regName[rs]);
		break;
	   case 6:
		sprintf(disBuf, "%08x %08x %-5s %s,%s", addrD, buf, snem[func], regName[rt], regName[rs]);
		break;
	   case 7:
		sprintf(disBuf, "%08x %08x %-5s %s,%s,0x%02x", addrD, buf, snem[func], regName[rd], regName[rt], sa);
		break;
	   case 3:
		sprintf(disBuf, "%08x %08x %-5s %s,%s,%s", addrD, buf, snem[func], regName[rd], regName[rs], regName[rt]);
		break;
	   case 11:
		sprintf(disBuf, "%08x %08x %-5s %s", addrD, buf, snem[func], regName[rd]);
		break;
	  default:
		sprintf(disBuf," S %-5s nem_mode: %2d buf: 0x%08x", snem[func], snem_mode[func], buf);
		break;
	 }


	break;
   default:
	sprintf(disBuf," N %-5s nem_mode: %2d buf: 0x%08x",nem[op],nem_mode[op],buf);
	break;
  }


}

