//#define _TEST

#include <stdio.h>
#include <dpmi.h>
#include "globals.h"

#ifdef _TEST
char buffer[400000];
#endif

void putline640(long line, char *addr)
{
 __dpmi_regs r; 
 int bank;
 long addrL;
 long size;
 line*=1280;
 bank = line/65536;
 addrL = line%65536;

 if(addrL+1280<=65536)
  {
   r.x.ax=0x4f05;
   r.x.bx=0x0000;
   r.x.dx=bank;
   __dpmi_int(0x10,&r);
   dosmemput(addr,1280,0xa000*16+addrL);
   return;
  }
 else
  {
   size=65536-addrL;
   r.x.ax=0x4f05;
   r.x.bx=0x0000;
   r.x.dx=bank;
   __dpmi_int(0x10,&r);
   dosmemput(addr,size,0xa000*16+addrL);
   r.x.ax=0x4f05;
   r.x.bx=0x0000;
   r.x.dx=bank+1;
   __dpmi_int(0x10,&r);
   addrL=0;
   dosmemput(addr+size,1280-size,0xa000*16+addrL);
  }
 return;
}

void putline640L(long line, long lineV, int posV, int width)
{
 __dpmi_regs r; 
 int bank;
 long addrL;
 long size;
 long addrV;

 if (width>640) width = 640;
 if (line>480) return;
 width = (width+31)/4;
 width *= 8;

 line= line * 1280;
 bank = line/65536;
 addrL = line%65536;

 addrV = lineV*2048+posV*2;

 if(addrL+width<=65536)
  {
   r.x.ax=0x4f05;
   r.x.bx=0x0000;
   r.x.dx=bank;
   __dpmi_int(0x10,&r);
   dosmemput(psxV+addrV,width,0xa000*16+addrL);
   return;
  }
 else
  {
   size=65536-addrL;
   r.x.ax=0x4f05;
   r.x.bx=0x0000;
   r.x.dx=bank;
   __dpmi_int(0x10,&r);
   dosmemput(psxV+addrV,size,0xa000*16+addrL);
   r.x.ax=0x4f05;
   r.x.bx=0x0000;
   r.x.dx=bank+1;
   __dpmi_int(0x10,&r);
   addrL=0;
   dosmemput(psxV+addrV+size,width-size,0xa000*16+addrL);
  }
 return;
}

void displayCL(long color)
{
 __dpmi_regs r; 
 int bank;
 long addrL;
 long size;
 long addrV;
 long width;
 long line;
 char buffer[1280];
 int i;

 width = 640;
 line = 0;
 width = (width+31)/4;
 width *= 8;
 for (i=0;i<1280;i++) buffer[i]=color;
 line= line * 1280;
 bank = line/65536;
 addrL = line%65536;

 r.x.ax=0x4f05;
 r.x.bx=0x0000;
 r.x.dx=bank;
 __dpmi_int(0x10,&r);
 dosmemput(buffer,width,0xa000*16+addrL);
 return;
}

short initDisplay(void)
{
 __dpmi_regs r; 

 r.x.ax=0x4f02;
 r.x.bx=0x110;
 __dpmi_int(0x10,&r);
 return r.x.ax;
}


#ifdef _TEST
void main(void)
{
 __dpmi_regs r; 
 FILE *in;
 long desc;
 int j;


 if (!(in = fopen("logo.tim","rb")))
  { 
   printf("PIC NOT FOUND\n");
   return;

  }
 fread(buffer,400000,1,in);
 fclose(in);
 r.x.ax=0x4f02;
 r.x.bx=0x110;
 __dpmi_int(0x10,&r);
// desc = __dpmi_segment_to_descriptor(0xa000);
 desc = 0xa000;
 for(j=0;j<256;j++) putline640(j,buffer+0x20+j*1280);
 while(!kbhit());

}


#endif
