/* (C) 1997 Duddie / Vision Thing Software Group */

/* THIS FILE WILL BE CONVERTED SOON TO BE ABLE FOR PORTING EMU */

#include <stdio.h>
#include <keys.h>
#include <pc.h>
#include <dos.h>
#include "grx20.h"
#include "globals.h"
#include "psxhead.h"
#include "funcs.h"
#include "texts.h"
#include "warn.h"
#include "cdrom.h"

#define lpCh 12

#define SM_DISASM 1
#define SM_MEMORY 2
#define SM_ASCII  3
#define SM_NONE	  4
#define SM_OPTIONS 5
#define SM_OUTPUT 6

#define REG_CPU	 0
#define REG_COP0 1
#define REG_NONE 2

void infoScreen(void);
void goCPU(void);
void goCPUF(long addrEnd);
void clearInfoLines(void);
void clearPrintArea(void);
void printDisasm(unsigned long);
void printMemory(unsigned long);
void printAscii(unsigned long disAddr);
void printOptions(void);
void printOutput(void);
void helpLine(void);
void errorLine(int);
void printRegs(void);
void myStatusLine0(char*);
unsigned long inputAddr(void);
char * inputString();
void psxLoadYaroze(char *name);

struct configPS
{
 char cdromLetter;
 int  loadRom;
 char romName[14];
 int  romNr;
};

struct configPS myconfPS = {'E',1,"SCPH1000.BIN",0};


FILE *logfile;
FILE *logHfile;
FILE *outfile;
FILE *tmpFile;
int idemode;
void *tempptr; 
int cursorPos;
struct time myTime;
struct time startTime;
struct time stopTime;
double exePerf;
double exePerf1;
double exePerf2;
int dispReg = 0;
char tmpstrL[100];
int activeLog = 1;
int i,j,k;
unsigned long vsyncCountM;

char *infoText = "PSEmu v0.01.22 (C)1997 Duddie";

char *helpLines[10] = {"","",
			"[ESC]-Exit [F5]-Walk [F6]-Step [F8]-Go [F9]-View [p]-NewPC [P]-PC=cur. [g]-GoAddr [G]-GoPC", "[l]-LoadExe [b]-ToggleBP [s]-ToggleSP [O]-Options [F11]-ChRegs [SH-F12]-Exe1st [F12]-ResetPSX",
			"[Y]es [N]o","",
			"[ESC]-exit without saving [ENTER]-exit and save","",
			};

char *romNames[4] = {"SCPH1000.BIN","SCPH5000.BIN","SCPH5500.BIN","DTLH3000.BIN"};




void main(void)
{
 int mykey;
 unsigned long disAddr;
 unsigned long tempStorage;
 int showMode;
 long cdiResult;

 tmpFile = fopen("pse.ini","rb");
 if (tmpFile)
  {
   fread(&myconfPS, sizeof(myconfPS), 1, tmpFile);
   fclose(tmpFile);
  }

 tmpFile = fopen("psxdev\\dummy.dev","rb");
 if (tmpFile)
  {
   fread(psxS, 0x1000, 1, tmpFile);
   fclose(tmpFile);
  }

 tempptr=psxV;
 psxVL=tempptr;

 tempptr=psxM;
 psxML=tempptr;
 psxMLS=tempptr;
 psxMW=tempptr;
 psxMWS=tempptr;
 
 tempptr=psxS;
 psxSL=tempptr;
 psxSLS=tempptr;
 psxSW=tempptr;
 psxSWS=tempptr;
 
 tempptr=psxR;
 psxRL=tempptr;
 psxRLS=tempptr;
 psxRW=tempptr;
 psxRWS=tempptr;

 tempptr=psxH;
 psxHL=tempptr;
 psxHLS=tempptr;
 psxHW=tempptr;
 psxHWS=tempptr;

 tempptr=reg;
 regS=tempptr;

 logfile = fopen("log.txt","w");
 logHfile = fopen("hardlog.txt","w");
 outfile = fopen("output.txt","w");
 fprintf (logfile, "*** LOG FILE ***\n");
 if (myconfPS.loadRom) loadRom(myconfPS.romName);

 GrSetMode(GR_width_height_color_graphics,800,600,256);

 resetPS();
 disAddr = rPC-15*4;
 showMode = SM_DISASM;
 idemode=1;
 cursorPos = 0;
 infoScreen();
 for (i=0;i<10;i++) 
  {
   breakpoints[i] = 0xffffffff;
   skips[i] = 0xffffffff;
  }
 latchHRead = latchHWrite = 0;

 cdiResult = dcdInit();


 stopTime.ti_sec = 50;
 do
 {
  exePerf1 = startTime.ti_hour*60 + startTime.ti_min;
  exePerf1 *= 60;
  exePerf1 += startTime.ti_sec;
  exePerf1 *= 50;
  exePerf1 += (startTime.ti_hund/2);

  exePerf2 = stopTime.ti_hour*60 + stopTime.ti_min;
  exePerf2 *= 60;
  exePerf2 += stopTime.ti_sec;
  exePerf2 *= 50;
  exePerf2 += (stopTime.ti_hund/2);

  exePerf2 -= exePerf1;

  exePerf = vsyncCountM*100;
  if(exePerf2>0) exePerf = exePerf / exePerf2;
  else exePerf = 0;
  
  while(!kbhit()) 
   {
    gettime(&myTime);
    sprintf(tmpstrL,"%d:%02d:%02d.%02d  SP: %.3f%% %c",myTime.ti_hour,myTime.ti_min,myTime.ti_sec,myTime.ti_hund,exePerf,activeLog?'A':' ');
    GrTextXY( 540,0,tmpstrL,GrWhite(),GrBlack());
   }
  mykey=getxkey();
  switch (idemode)
  {
   case 2: // EXIT MODE
    if (mykey == 'Y' || mykey == 'y')  idemode=0;
    if (mykey == 'N' || mykey == 'n')  idemode=1;
    break;
   case 1:
    clearInfoLines();
    helpLine();
    if (mykey == 27) idemode=2;
    if (mykey == 390) // F12
     {
      resetPS();
      disAddr = rPC-15*4;
      showMode = SM_DISASM;
     }
    if (mykey == 392) // SH-F12
     {
      goCPUF(0x80030000);
      disAddr = rPC-15*4;
      showMode = SM_DISASM;
     }
    if (mykey == 320) rPC+=4;
    if (mykey == 319) 
     {
      cpuError = 0;
      doInstr();
      doGPU();
      disAddr = rPC-15*4;
      showMode = SM_DISASM;
     }
    if (mykey == 322) // F8
     {
      GrClearScreen(GrBlack());
      initDisplay();
      goCPU();
      GrSetMode(GR_width_height_color_graphics,800,600,256);
      GrClearScreen(GrBlack());
      disAddr = rPC-15*4;
      cursorPos = 15;
      showMode = SM_DISASM;
     }
    if (mykey == 347) // SH-F8
     {
      GrClearScreen(GrBlack());
      initDisplay();
      goCPUF(disAddr+cursorPos*4);
      GrSetMode(GR_width_height_color_graphics,800,600,256);
      GrClearScreen(GrBlack());
      disAddr = rPC-15*4;
      cursorPos = 15;
      showMode = SM_DISASM;
     }
    if (mykey == 323) // F9
     {
      if(showMode == SM_OUTPUT) showMode=SM_DISASM;
      if((++showMode) == SM_NONE) showMode=SM_DISASM;
      clearPrintArea();
     }
    if (mykey == 324) // F10
     {
      if(showMode == SM_OUTPUT) showMode=SM_DISASM;
      else showMode = SM_OUTPUT;
      clearPrintArea();
     }
    if (mykey == 389) // F11
     {
      if((++dispReg) == REG_NONE) dispReg=REG_CPU;
     }
     
    if (mykey == 'l')  
     {
      psxLoad(inputString());
      disAddr = rPC-15*4;
      showMode = SM_DISASM;
     }

    if (mykey == 'd') activeLog = 1;
    if (mykey == 'D') activeLog = 0;

    if (mykey == 'L')  
     {
      psxLoadYaroze(inputString());
//	disAddr = rPC-15*4;
      showMode = SM_DISASM;
     }

    if (mykey == 'O' || mykey == 'o')
     {
      idemode=3;
      showMode=SM_OPTIONS;
     }
    if (mykey == 'P' && showMode == SM_DISASM)
      rPC=disAddr+cursorPos*4;
    if (mykey == 'p')
     {
      tempStorage = rPC;
      rPC = inputAddr();
      if (rPC == 0xffffffff) rPC = tempStorage;
      rPC&=0xfffffffc;
     }
    if (mykey == 'G')
     {
      disAddr = rPC-15*4;
      cursorPos = 15;
     }
    if (mykey == 'g')
     {
      cursorPos=0;
      tempStorage = disAddr;
      disAddr = inputAddr();
      if (disAddr == 0xffffffff) disAddr = tempStorage;
      disAddr&=0xfffffffc;
     }
     
    if ((mykey == 584) && (showMode==SM_DISASM))
     if(cursorPos==0) disAddr-=4; else cursorPos--;
    if ((mykey == 592) && (showMode==SM_DISASM)) 
     if(cursorPos==30) disAddr+=4; else cursorPos++;
    if ((mykey == 584) && (showMode==SM_MEMORY))
     if(cursorPos==0) disAddr-=16; else cursorPos--;
    if ((mykey == 592) && (showMode==SM_MEMORY))
     if(cursorPos==30) disAddr+=16; else cursorPos++;
    if ((mykey == 585) && (showMode==SM_DISASM)) disAddr-=32*4;
    if ((mykey == 593) && (showMode==SM_DISASM)) disAddr+=32*4;
    if ((mykey == 585) && (showMode==SM_MEMORY)) disAddr-=32*0x10;
    if ((mykey == 593) && (showMode==SM_MEMORY)) disAddr+=32*0x10;

    if (mykey == 'b' && showMode == SM_DISASM)
     setBreakPoint( disAddr+(cursorPos*4));
    if (mykey == 's' && showMode == SM_DISASM)
     setSkipPoint( disAddr+(cursorPos*4));
   break;


   case 3:
    if (mykey == 'A' || mykey == 'a')
    {
     int myKeyX;
     do
      myKeyX=getxkey();
     while(!((myKeyX>'b' & myKeyX<='z') | (myKeyX>'B' & myKeyX<='Z')));
     if (myKeyX >= 'a') myKeyX-=0x20;
     myconfPS.cdromLetter=(char) myKeyX;
    }

    if (mykey == 'B' || mykey == 'b')
     {
      if (myconfPS.loadRom==1) myconfPS.loadRom=0;
      else myconfPS.loadRom=1;
     }
    if (mykey == 'C' || mykey == 'c')
     {
      myconfPS.romNr++;
      if (myconfPS.romNr > 3) myconfPS.romNr = 0;
      sprintf(myconfPS.romName, "%s", romNames[myconfPS.romNr]);
     }
     
    if (mykey == 27)
     {
      idemode=1;
      showMode=SM_DISASM;
     }

    if (mykey == 13)
    {
    tmpFile = fopen("pse.ini","wb");
    if (tmpFile)
     {
      fwrite(&myconfPS, sizeof(myconfPS), 1, tmpFile);
      fclose(tmpFile);
     }
    idemode=1;
    showMode=SM_DISASM;
    }	
   break;
  }

//  printRegs();
//  printCursor();

   clearInfoLines();
   errorLine(cpuError);
   GrTextXY( 0,0,infoText,GrWhite(),GrBlack());
   helpLine();
   if (showMode == SM_DISASM) printDisasm(disAddr);
   if (showMode == SM_MEMORY) printMemory(disAddr);
   if (showMode == SM_ASCII) printAscii(disAddr);
   if (showMode == SM_OPTIONS)
   {
    clearPrintArea();
    printOptions();
   }
   if (showMode == SM_OUTPUT)
   {
    clearPrintArea();
    printOutput();
   }
   printRegs();

//   sprintf(tmpBuf, "%d   %c     ",mykey,(char)mykey);
//   GrTextXY( 600,0,tmpBuf,GrWhite(),GrBlack());

 } while (idemode != 0);

 GrSetMode(GR_default_graphics);
 dcdStop();
 dcdRemove();
 fclose(outfile);
 fclose(logfile);
 fclose(logHfile);
 return;
}



unsigned long loadTemp4(unsigned long addrD)
{
unsigned long addrPref, addrR;
addrPref = (addrD >> 28) & 0xf;
addrR=addrD & 0xfffffff;
if ((addrPref==0 || addrPref==8 || addrPref==0xA) && addrR < Meg8)
 {
  addrR &= 0x1fffff;
  return psxML[addrR/4];
 }
else if (addrD>=0xbfc00000 && addrD<0xbfc80000)
 {
  addrR &= 0x7ffff;
  return psxRL[addrR/4];
 }
else if (addrD>=0x1f800000 && addrD<0x1f880000)
 {
  addrR &= 0x7ffff;
  return psxHL[addrR/4];
 }
else if (addrD>=0x1f000000 && addrD<0x1f001000)
 {
  addrR &= 0xfff;
  return psxSL[addrR/4];
 }
else
  return 0xaaaaaaaa;
}



unsigned long inputAddr(void)
{
 unsigned long tempL;
 int myKey;
 tempL = 0;
 for(i=0;i<8;)
 {
    sprintf(tmpBuf, "Enter address: 0x%x_ ", tempL);
    myStatusLine0(tmpBuf);
    myKey=getxkey();
    if (myKey>='0' && myKey<='9')
    {
     tempL = (tempL << 4) | (myKey - '0');
     i++;
    }
    if (myKey>='a' && myKey<='f')    {
      tempL = (tempL << 4) | (myKey - 'a'+10);
     i++;    }
    if (myKey>='A' && myKey<='F')    {
     tempL = (tempL << 4) | (myKey - 'A'+10);
     i++;    }
    if (myKey==27) return 0xffffffff;
    if ((myKey==8) && (i>0))
     {
      tempL=(tempL >> 4)&0x0fffffff;
      i--;
     }
 }
 return tempL;
}

char * inputString(void)
{
 int myKey;
 for(i=0;i<20;i++) tmpstrL[i]=0;
 for(i=0;i<20;)
 {
    sprintf(tmpBuf, "Enter name: %s_ ", tmpstrL);
    myStatusLine0(tmpBuf);
    myKey=getxkey();
    if (myKey>=' ' && myKey<=127)
    {
     tmpstrL[i]=(char)myKey;
     i++;
    }
    if (myKey==13) return tmpstrL;
    if ((myKey==8) && (i>0))
    {
     i--;
     tmpstrL[i]=0;
    }
 }
 return tmpstrL;
}
void myStatusLine0(char *text)
 {
  GrTextXY( 0,544,text,GrWhite(),GrBlack());
 }

void helpLine(void)
 {
  GrTextXY( 0,568,helpLines[idemode*2],GrWhite(),GrBlack());
  GrTextXY( 0,580,helpLines[idemode*2+1],GrWhite(),GrBlack());
 }

void errorLine(int errorNr)
 {
  if (!errorNr)
   sprintf(tmpBuf, "OK!");
  else if (errorNr == CPU_NOTIMPLEMENTED)
   sprintf(tmpBuf, "CPU COMMAND NOT IMPLEMENTED");
  else if (errorNr == CPU_DONE)
   sprintf(tmpBuf, "EXECUTE COMPLETED");
  else if (errorNr < CPU_WARN)					 
   sprintf(tmpBuf, "ERROR: %d", errorNr);
  else 
   sprintf(tmpBuf, " ");
  GrTextXY( 0,556,tmpBuf,GrWhite(),GrBlack());
 }

void clearInfoLines(void)
 {
  for (i=0;i<254;i++) tmpBuf[i]=' ';
  tmpBuf[i]=0;
  GrTextXY( 0,544,tmpBuf,GrWhite(),GrBlack());
  GrTextXY( 0,556,tmpBuf,GrWhite(),GrBlack());
  GrTextXY( 0,568,tmpBuf,GrWhite(),GrBlack());
  GrTextXY( 0,580,tmpBuf,GrWhite(),GrBlack());
 }

void clearPrintArea(void)
{
 int pLine = 3;
 for(i=0;i<31;i++)
  {
   GrTextXY(48,(pLine+i)*lpCh,"                                                         ",GrWhite(),GrBlack());
  }
}
void printMemory(unsigned long disAddr)
{
 int pLine = 3;
 char tmpstr[256];
 char cursorHere;
 
 for(i=0;i<31;i++)
  {
   if (i==cursorPos) cursorHere='>';
    else cursorHere=' ';
   sprintf(tmpstr,"%c %08x   %08x %08x %08x %08x ",cursorHere,disAddr,loadTemp4(disAddr),loadTemp4(disAddr+4),loadTemp4(disAddr+8),loadTemp4(disAddr+0xc));
   disAddr+=0x10;
   GrTextXY(48,(pLine+i)*lpCh,tmpstr,GrWhite(),GrBlack());
  }
}

void printAscii(unsigned long disAddr)
{
 int pLine = 3;
 char tmpstr[256];
 char tmpstr2[256];
 char cursorHere;
 long tmpLong, countC;
 unsigned char tmpChar;
 
 for(i=0;i<31;i++)
  {
   countC=0;
   for (j=0;j<8;j++)
   {
    tmpLong=loadTemp4(disAddr);
    disAddr+=4;
    for (k=0;k<4;k++)
     {
      tmpChar = tmpLong&0xff;
      tmpLong >>= 8;
      if (tmpChar>=32 && tmpChar<128) tmpstr2[countC]=tmpChar;
      else tmpstr2[countC]='.';
      countC++;
     }
   }
   tmpstr2[countC]=0;
   if (i==cursorPos) cursorHere='>';
    else cursorHere=' ';
   sprintf(tmpstr,"%c %08x   %s ",cursorHere,disAddr,tmpstr2);
   GrTextXY(48,(pLine+i)*lpCh,tmpstr,GrWhite(),GrBlack());
  }
}

void printOptions(void)
{
 int pLine = 3;
 char tmpstr[256];
 char *optionsText[10] = {"[A] CD-ROM drive letter: %c ",
			 "[B] Load BIOS image? : %s   ",
			 "[C] BIOS image name: %s  ",
			 "[D] Save breakpoints?: %s  ",
			 };
 i=0;			      
 sprintf(tmpstr, optionsText[i], myconfPS.cdromLetter);
 GrTextXY(48,(pLine+i)*lpCh,tmpstr,GrWhite(),GrBlack());
 i++;
 sprintf(tmpstr, optionsText[i], myconfPS.loadRom?"Yes":"No");
 GrTextXY(48,(pLine+i)*lpCh,tmpstr,GrWhite(),GrBlack());
 i++;
 sprintf(tmpstr, optionsText[i], myconfPS.romName);
 GrTextXY(48,(pLine+i)*lpCh,tmpstr,GrWhite(),GrBlack());
 i++; 

}
void printDisasm(unsigned long disAddr)
{
 int pLine = 3;
 char cursorHere;
 char bkPoint[3];
 char tmpstr[256];

 bkPoint[2]=0;
 
  for(i=0;i<31;i++)
   {
    bkPoint[0]=' ';
    bkPoint[1]=' ';
    for (k=0;k<10;k++)
    {
     if (breakpoints[k]==disAddr) bkPoint[0]=0x42;
     if (skips[k]==disAddr) bkPoint[1]='S';
    }
    if (i==cursorPos) cursorHere='>';
     else cursorHere=' ';

	
    disasmLine(disAddr);
    sprintf(tmpstr,"%s %c%s", bkPoint, cursorHere, disBuf);
    GrTextXY(48,(pLine+i)*lpCh,"                                                ", GrWhite(), GrBlack());
    if(disAddr == rPC)
     GrTextXY(48,(pLine+i)*lpCh,tmpstr,2,GrBlack());
    else
     GrTextXY(48,(pLine+i)*lpCh,tmpstr,GrWhite(),GrBlack());
    disAddr+=4;
   }
}

void printRegs(void)
 {
  int pLine = 3;
  char tmpstr[256];
  
  sprintf(tmpBuf, "  pc = 0x%08x",rPC);
  GrTextXY(540,pLine*lpCh,tmpBuf,GrWhite(),GrBlack());
  pLine++;

  for(i=0;i<=31;i++)
   {
/*    compAddr = reg[i]-Mbase;
    if (compAddr>0 && compAddr<TwoMeg)
    for(j=0;j<=9;j++)
      {
       if(psxM[compAddr+j]>31 && psxM[compAddr+j]<128) tmpstr[j]=psxM[compAddr+j];
       else tmpstr[j]=' ';
      }	    
*/    

    if (dispReg == REG_CPU)
    {
     sprintf(tmpBuf, "%4s = 0x%08x  ",regName[i],reg[i]);
     GrTextXY( 540,(pLine+i)*lpCh,tmpBuf,GrWhite(),GrBlack());
    }
    else
    if (dispReg == REG_COP0)
    {
     sprintf(tmpBuf, "%-6s = 0x%08x",copReg[i],regCOP0[i]);
     GrTextXY( 540,(pLine+i)*lpCh,tmpBuf,GrWhite(),GrBlack());
    }
   }
  pLine+=i;
  sprintf(tmpBuf, "  HI = 0x%08x",regHI);
  GrTextXY(540,pLine*lpCh,tmpBuf,GrWhite(),GrBlack());
  pLine++;
  sprintf(tmpBuf, "  LO = 0x%08x",regLO);
  GrTextXY(540,pLine*lpCh,tmpBuf,GrWhite(),GrBlack());
  pLine++;
//  sprintf(tmpBuf, "  SR = 0x%08x",regCOP0[12]);
//  GrTextXY(540,pLine*lpCh,tmpBuf,GrWhite(),GrBlack());
}

int psxLoad(char *name) /* loads exe file into memory */
{
 FILE *tmpFile;
 EXE_HEADER tmpHead;
 
 if (tmpFile = fopen(name,"rb"))
  {
   fread(&tmpHead,sizeof(EXE_HEADER),1,tmpFile);
   fseek(tmpFile, 0x800, SEEK_SET); 
   if (tmpHead.t_addr > Mbase)
    {
     fread(psxM+(tmpHead.t_addr-Mbase), tmpHead.t_size,1,tmpFile);
     fclose(tmpFile);
     rPC = tmpHead.pc0;
     reg[28] = tmpHead.gp0;
     reg[29] = tmpHead.s_addr;
     fprintf(logfile,"EXE TYPE : %s\n",tmpHead.id);
     fprintf(logfile,"Data     : %x\n",tmpHead.data);
     fprintf(logfile,"Text     : %x\n",tmpHead.text);
     fprintf(logfile,"T Addr   : %x\n",tmpHead.t_addr);
     fprintf(logfile,"D Addr   : %x\n",tmpHead.d_addr);
     fprintf(logfile,"B Addr   : %x\n",tmpHead.b_addr);
     fprintf(logfile,"S Addr   : %x\n",tmpHead.s_addr);
     fprintf(logfile,"PC       : %x\n",tmpHead.pc0);
     return TRUE;
    }
    else return FALSE;
  }
  else return FALSE;
}

void psxLoadYaroze(char *name)
{
 if (tmpFile = fopen(name,"rb"))
  {
//   fread(&tmpHead,sizeof(EXE_HEADER),1,tmpFile);
   fseek(tmpFile, 0x1000, SEEK_SET); 
   fread(psxM+(0x80100000-Mbase), 0x3d0,1,tmpFile);
   fclose(tmpFile);
  }
}




void goCPUN(void)
{
 int i;
 do
  {
   if(latchHRead) doGPURead();
   if(latchHWrite) doGPUWrite();
   doGPU();
   for (i=0;i<10;i++) if (skips[i] == rPC) skipInstr();
   doInstr();
   if ((cpuError!=CPU_OK) && (cpuError<CPU_WARN)) return;
   for (i=0;i<10;i++) if (breakpoints[i] == rPC) return;
 }
 while(!kbhit());
}
void goCPU(void)
{
 vsyncCountM = vsyncCount;
 gettime(&startTime);
 goCPUN();
 gettime(&stopTime);
 vsyncCountM = vsyncCount - vsyncCountM;
}

void goCPUF(long addrEnd)
{
 vsyncCountM = vsyncCount;
 gettime(&startTime);
 do
  {
   if(latchHRead) doGPURead();
   if(latchHWrite) doGPUWrite();
   doGPU();
   doInstr();
  }
 while (rPC!=addrEnd);
 gettime(&stopTime);
 vsyncCountM = vsyncCount - vsyncCountM;
}


void infoScreen(void)
{
 char *infoTexts[10]={	"",
			"          PSEmu - PlayStation Emulator",
			"",
			"                (C)1997 Duddie ",
			"",
			"  The lights say move, say never look back...",
			"",
			"     Drop a note: duddie@xgryf.gryf.com.pl",
			"          Feel free to get it from:",
			" http://xgryf.gryf.com.pl/~duddie/psxemu.html"
			};

 int pLine = 3;
 char tmpstr[256];
 char cursorHere;
 
 for(i=0;i<10;i++)
  {
   GrTextXY(48,(pLine+i)*lpCh,infoTexts[i],GrWhite(),GrBlack());
  }
}
void printOutput(void)
{
 FILE *tf;
 char outLines[40][256];
 int count;
 unsigned char myByte;
 int i, j;
 int pLine = 3;
 int lastSkip;

 fclose(outfile);
 for (i=0;i<30;i++) outLines[i][0]=0;

 tf = fopen("output.txt", "rb");
 if (!tf) return;
 count = 0;
 while (fread(&myByte,1,1,tf))
  {
   if (myByte == 0x0d) count++;
  };
 fclose (tf);

 if (count == 0) return;
 tf = fopen("output.txt", "rb");
 i = 0;
 if (count > 30)
  while(i<(count-29))
   {
    fread(&myByte,1,1,tf);
    if (myByte == 0x0d) i++;
   };
 j=0; i=0;
 lastSkip = 0;
 while (fread(&myByte,1,1,tf))
  {
   if(myByte == 0x0a || myByte == 0x0d)
    {
     if(lastSkip==0)
      {
       outLines[i][j]=0;
       i++; j=0;
       lastSkip=1;
      }
    }
   else
   if(myByte == 0x09)
    {
     outLines[i][j] = ' ';
     j++;
     lastSkip=0;
    }
   else
    {
     lastSkip=0;
     outLines[i][j] = myByte;
     j++;
    }
  }
 for(i=0;i<30;i++)
  {
   GrTextXY(48,(pLine+i)*lpCh,outLines[i],GrWhite(),GrBlack());
  }
 fclose(tf);
 outfile = fopen("output.txt","a");
}