/* This exe header is based on stuff from Sergio's Page */
/* I've not changed a lot */


#ifndef _EXEHEAD
#define _EXEHEAD

typedef struct _EXE_HEADER_ {
        unsigned char id[8];
        unsigned long text;                    /* SCE only */
        unsigned long data;                    /* SCE only */
        unsigned long pc0;
        unsigned long gp0;                     /* SCE only */
        unsigned long t_addr;
        unsigned long t_size;
        unsigned long d_addr;                  /* SCE only */
        unsigned long d_size;                  /* SCE only */
        unsigned long b_addr;                  /* SCE only */
        unsigned long b_size;                  /* SCE only */
        unsigned long s_addr;
        unsigned long s_size;
        unsigned long SavedSP;
        unsigned long SavedFP;
        unsigned long SavedGP;
        unsigned long SavedRA;
        unsigned long SavedS0;
} EXE_HEADER;

/*                                Explanation

   * ExeType = { 'SCE EXE' || 'PS-X EXE' };
   * text - Offset of the text segment
   * data - Offset of the data segment
   * pc0 - Program Counter.
   * gp0 - Address of the Global Pointer
   * t_addr - The address where the text segment is loaded
   * t_size - The size of the text segment
   * d_addr - The address where the text segment is loaded
   * d_size - The size of the data segment
   * b_addr - The address of the BSS segment
   * b_size - The size of the BSS segment
   * s_addr - The address of the stack
   * s_size - The size of the stack.
   * SavedXX - The Exec system call saves some registers to these fields
     before jumping to the program.

*/
#endif