/* (C) 1997 Duddie / Vision Thing Software Group */

#include <stdio.h>
#include <math.h>
#include "globals.h"
#include "romfuncs.h"
#include "gpufuncs.h"
#include "opfuncs.h"
#include "warn.h"


#define incPC rPC+=4

unsigned long buf;
unsigned long imedU;
signed long imedS;
unsigned int rt, rs;
unsigned int rd,sa,func;
unsigned int op;
unsigned long addrR, addrPref;
unsigned long Jaddr, Baddr;
unsigned long newPC;
unsigned long hardInterrupt;
signed long compDataS;
signed long compDataS1;
signed long compDataS2;
unsigned char compDataB1;
unsigned char compDataB2;
unsigned long VideoAccess;
unsigned long hardAccess;
double long multRes;
unsigned long latchHRead;
unsigned long latchHWrite;
unsigned long regLOd;
unsigned long regHId;
unsigned long mulDelay;
int cpuError;
int interEnable = 1;
unsigned int curPos;
char tmpstr[256];


void (*opF[64])(void) = {opSP,opREGIMM,opJ,opJAL,opBEQ,opBNE,opBLEZ,opBGTZ,
			 opADDI,opADDIU,opSLTI,opSLTIU,opANDI,opORI,opXORI,opLUI,
			 opCOP0,opNI,opCOP2,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
			 opLB,opLH,opLWL,opLW,opLBU,opLHU,opLWR,opNI,
			 opSB,opSH,opSWL,opSW,opNI,opNI,opSWR,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI};


void (*opFS[64])(void) = {opSLL,opNI,opSRL,opSRA,opSLLV,opNI,opSRLV,opSRAV,
			 opJR,opJALR,opNI,opNI,opSYSCALL,opBREAK,opNI,opNI,
			 opMFHI,opMTHI,opMFLO,opMTLO,opNI,opNI,opNI,opNI,
			 opMULT,opMULTU,opDIV,opDIVU,opNI,opNI,opNI,opNI,
			 opADD,opADDU,opSUB,opSUBU,opAND,opOR,opXOR,opNOR,
			 opNI,opNI,opSLT,opSLTU,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI};

void (*opFR[32])(void) = {
			 opBLTZ,opBGEZ,opNI,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI,
			 opNI,opNI,opNI,opNI,opNI,opNI,opNI,opNI
			};



int loadBufU(unsigned long addrD)
{
addrPref = (addrD >> 28) & 0xf;
addrR=addrD & 0xfffffff;
if ((addrPref==0 || addrPref==8 || addrPref==0xA) && (addrR < Meg8))
 {
  addrR &= 0x1fffff;
  buf = psxML[addrR/4];
//  if (activeLog) if (addrD == 0x80015e78) fprintf(outfile,"Loading at %08x %08x\n",rPC,buf);
  return CPU_OK;
 }
else if (addrD>=0xbfc00000 && addrD<0xbfc80000)
 {
  addrR &= 0x7ffff;
  buf = psxRL[addrR/4];
  return CPU_OK;
 }
else if (addrD>=0x1f800000 && addrD<0x1f880000)
 {
  latchHRead = addrR;
  addrR &= 0xffff;
  buf = psxHL[addrR/4];
  cpuError = CPU_EXECUTING_HARD;
  return cpuError;
 }
else if (addrD>=0x1f000000 && addrD<0x1f001000)
 {
  addrR &= 0xfff;
  buf = psxSL[addrR/4];
  return CPU_OK;
 }
else
 {
  cpuError = CPU_NO_MEMORY_THERE;
  return cpuError;
 }
}

int loadBufUW(unsigned long addrD)
{
addrPref = (addrD >> 28) & 0xf;
addrR=addrD & 0xfffffff;
if ((addrPref==0 || addrPref==8 || addrPref==0xA) && addrR < Meg8)
 {
  addrR &= 0x1fffff;
  buf = psxMW[addrR/2];
  return CPU_OK;
 }
else if (addrD>=0xbfc00000 && addrD<0xbfc80000)
 {
  addrR &= 0x7ffff;
  buf = psxRW[addrR/2];
  return CPU_OK;
 }
else if (addrD>=0x1f800000 && addrD<0x1f880000)
 {
  latchHRead = addrR;
  addrR &= 0xffff;
  buf = psxHW[addrR/2];
  cpuError = CPU_EXECUTING_HARD;
  return cpuError;
 }
else if (addrD>=0x1f000000 && addrD<0x1f001000)
 {
  addrR &= 0xfff;
  buf = psxSW[addrR/2];
  return CPU_OK;
 }
else
 {
  cpuError = CPU_NO_MEMORY_THERE;
  return cpuError;
 }
}

int loadBufUB(unsigned long addrD)
{
addrPref = (addrD >> 28) & 0xf;
addrR=addrD & 0xfffffff;
if ((addrPref==0 || addrPref==8 || addrPref==0xA) && addrR < Meg8)
 {
  addrR &= 0x1fffff;
  buf = psxM[addrR];
  return CPU_OK;
 }
else if (addrD>=0xbfc00000 && addrD<0xbfc80000)
 {
  addrR &= 0x7ffff;
  buf = psxR[addrR];
  return CPU_OK;
 }
else if (addrD>=0x1f800000 && addrD<0x1f880000)
 {
  addrR &= 0xffff;
  buf = psxH[addrR];
  cpuError = CPU_EXECUTING_HARD;
  latchHRead = addrR;
  return cpuError;
 }
else if (addrD>=0x1f000000 && addrD<0x1f001000)
 {
  addrR &= 0xfff;
  buf = psxS[addrR];
  cpuError = CPU_EXECUTING_HARD;
  return cpuError;
 }
else
 {
  cpuError = CPU_NO_MEMORY_THERE;
  return cpuError;
 }
}

int storeBufU(unsigned long addrD, unsigned long bufL)
{
//if (activeLog) if (addrD == 0x80015e78) fprintf(outfile,"Storing at 78 %08x %08x\n",rPC,bufL);
//if (activeLog) if (addrD == 0x80015e64) fprintf(outfile,"Storing at 64 %08x %08x\n",rPC,bufL);
addrPref = (addrD >> 28) & 0xf;
addrR=addrD & 0xfffffff;
if ((addrPref==0 || addrPref==8 || addrPref==0xA) && addrR < Meg8)
 {
  addrR &= 0x1fffff;
  if(!(regCOP0[12]&0x00010000)) psxML[addrR/4] = bufL;
  return CPU_OK;
 }
else if (addrD>=0xbfc00000 && addrD<0xbfc80000)
 {
  addrR &= 0x7ffff;
  psxRL[addrR/4] = bufL;
  return CPU_OK;
 }
else if (addrD>=0x1f800000 && addrD<0x1f880000)
 {
  latchHWrite = addrR;
  addrR &= 0xffff;
  hardStoreW(addrR, bufL);
  cpuError = CPU_EXECUTING_HARD;
  return cpuError;
 }
else if (addrD>=0x1f000000 && addrD<0x1f001000)
 {
  addrR &= 0xfff;
  psxSL[addrR/4] = bufL;
  cpuError = CPU_EXECUTING_HARD;
  return cpuError;
 }
else
 {
  cpuError = CPU_NO_MEMORY_THERE;
  return cpuError;
 }
}

int storeBufUW(unsigned long addrD, unsigned short bufL)
{
addrPref = (addrD >> 28) & 0xf;
addrR=addrD & 0xfffffff;
if ((addrPref==0 || addrPref==8 || addrPref==0xA) && addrR < Meg8)
 {
  addrR &= 0x1fffff;
  psxMW[addrR/2] = bufL;
  return CPU_OK;
 }
else if (addrD>=0xbfc00000 && addrD<0xbfc80000)
 {
  addrR &= 0x7ffff;
  psxRW[addrR/2] = bufL;
  return CPU_OK;
 }
else if (addrD>=0x1f800000 && addrD<0x1f880000)
 {
  addrR &= 0xffff;
  latchHWrite = addrR;
  hardStoreH(addrR, bufL);
//  psxHW[addrR/2] = bufL;
  cpuError = CPU_EXECUTING_HARD;
  return cpuError;
 }
else if (addrD>=0x1f000000 && addrD<0x1f001000)
 {
  addrR &= 0xfff;
  psxSW[addrR/2] = bufL;
  cpuError = CPU_EXECUTING_HARD;
  return cpuError;
 }
else
 {
  cpuError = CPU_NO_MEMORY_THERE;
  return cpuError;
 }
}

int storeBufUB(unsigned long addrD, unsigned char bufL)
{
addrPref = (addrD >> 28) & 0xf;
addrR=addrD & 0xfffffff;
if ((addrPref==0 || addrPref==8 || addrPref==0xA) && addrR < Meg8)
 {
  addrR &= 0x1fffff;
  psxM[addrR] = bufL;
  return CPU_OK;
 }
else if (addrD>=0xbfc00000 && addrD<0xbfc80000)
 {
  addrR &= 0x7ffff;
  psxR[addrR] = bufL;
  return CPU_OK;
 }
else if (addrD>=0x1f800000 && addrD<0x1f880000)
 {
  addrR &= 0x7ffff;
  psxH[addrR] = bufL;
  cpuError = CPU_EXECUTING_HARD;
  latchHWrite = addrR;
  return cpuError;
 }
else if (addrD>=0x1f000000 && addrD<0x1f001000)
 {
  addrR &= 0xfff;
  psxS[addrR] = bufL;
  cpuError = CPU_EXECUTING_HARD;
  return cpuError;
 }
else
 {
  cpuError = CPU_NO_MEMORY_THERE;
  return cpuError;
 }
}

unsigned long getBaddr(addrD)
{
 return (imedS << 2) + addrD + 4;
}

/* ---------------------------------------------- */

void doInstr(void)
{
 if(hardInterrupt==1)
  {
   hardInterrupt=0;
   if (interEnable)
    {
     regCOP0[13]=0x400;
     if ( ((regCOP0[13] & regCOP0[12] & 0x400)==0x400) )
      {
       regCOP0[12] |= 0x2;
       interEnable = 0;
       regCOP0[14]=rPC;
       rPC=0x80;
       if (activeLog) fprintf(outfile,"!PSE! Interrupt taken\n");
      }
    }
  }
 cpuError=CPU_OK;
 if(!loadBufU(rPC))
 {
  regCOP0[9]++;
  op = (buf >> 26) & 0x3f;
  imedU = buf & 0x0000ffff;
  imedS=imedU;
  if (imedU > 0x7fff) imedS = imedU |0xffff0000;
  rt = (buf >> 16) & 0x1f;
  rs = (buf >> 21) & 0x1f;
  rd = (buf >> 11) & 0x1f;
  opF[op]();
 }
 reg[0]=0;
}

void skipInstr(void)
{
 cpuError=CPU_OK;
 if(!loadBufU(rPC)) incPC;
}

void go(void)
{
/* VideoAccess = 0;
  psxHL[0x1110/4]=0xffffffff;
  psxHL[0x1814/4]=0xffffffff;

 while(kbhit()!=0);
 do
 {
  disCT = rPC - Mbase;
  op = (psxM[disCT+3] & 0xfc) >> 2;
  buf = *(psxML+disCT/4);
  imed = buf & 0x0000ffff;
  rt = (buf >> 16) & 0x1f;
  rs = (buf >> 21) & 0x1f;
  psxHL[0x1814/4]^=0xaaaaaaaa;
  opF[op]();
  for (i=0;i<10;i++) if (breakpoints[i] == rPC) operationGood = FALSE;
 } while (operationGood && (kbhit()==0));
  sprintf(tmpstr, "VIDEO ACCESSED %d TIMES           ",VideoAccess);
  GrTextXY(40,520,tmpstr,GrWhite(),GrBlack());
  sprintf(tmpstr, "HARDWARE ACCESSED %d TIMES           ",HardAccess);
  GrTextXY(40,540,tmpstr,GrWhite(),GrBlack());*/
}


int setBreakPoint(unsigned long bpAddr)
{
int i;
 for (i=0; i<10;i++)
   if (breakpoints[i] == bpAddr) 
    {
     breakpoints[i] = 0xffffffff;
     return TRUE;
    }
 for (i=0; i<10;i++)
   if (breakpoints[i] == 0xffffffff) 
   {
    breakpoints[i] = bpAddr;
    return TRUE;
   }
return FALSE;
}

int setSkipPoint(unsigned long spAddr)
{
int i;
 for (i=0; i<10;i++)
   if (skips[i] == spAddr) 
    {
     skips[i] = 0xffffffff;
     return TRUE;
    }
 for (i=0; i<10;i++)
   if (skips[i] == 0xffffffff) 
   {
    skips[i] = spAddr;
    return TRUE;
   }
return FALSE;
}

void opNI(void)
{
func = buf & 0x3f;
if (op>1) 
sprintf(tmpBuf, "NOT IMPLEMENTED! %s           ",nem[op]);
else if (op=1)
sprintf(tmpBuf, "NOT IMPLEMENTED! regimm %s           ",rnem[rt]);
else
sprintf(tmpBuf, "NOT IMPLEMENTED! spec %s           ",snem[func]);
cpuError=CPU_NOTIMPLEMENTED;
}



void opSP(void)
{
func = buf & 0x3f;
if (buf) opFS[func]();
else incPC;
}

void opREGIMM(void)
{
if (reg_mode[rt]==5) opFR[rt]();
else opNI();
}




/* COMPUTATIONAL INSTRUCTIONS */


void opADDI(void)
{
reg[rt]=reg[rs]+imedS;
incPC;
}

void opADDIU(void)
{
reg[rt]=reg[rs]+imedS;
incPC;
}

void opAND(void)
{
reg[rd]=reg[rs] & reg[rt];
rPC+=4;
}

void opANDI(void)
{
reg[rt]=reg[rs] & imedU;
incPC;
}

void opSLTI(void)
{
if (regS[rs] < imedS) reg[rt] = 1;
else reg[rt] = 0;
incPC;
}

void opSLTIU(void)
{
if (reg[rs] < imedU) reg[rt] = 1;
else reg[rt] = 0;
incPC;
}


void opSUBU(void)
{
reg[rd]=reg[rs] - reg[rt];
incPC;
}

void opADDU(void)
{
reg[rd]=reg[rs] + reg[rt];
rPC+=4;
}

void opOR(void)
{
reg[rd]=reg[rt] | reg[rs];
rPC+=4;
}

void opNOR(void)
{
reg[rd]=(reg[rt] | reg[rs]) ^ 0xffffffff;
rPC+=4;
}

void opADD(void)
{
reg[rd]=reg[rs] + reg[rt];
rPC+=4;
}

void opSUB(void)
{
reg[rd]=reg[rs] - reg[rt];
rPC+=4;
}

void opORI(void)
{
reg[rt]=reg[rs] | imedU;
rPC+=4;
}

void opSLTU(void)
{
if (reg[rs] < reg[rt]) reg[rd]=1;
else reg[rd]=0;
rPC+=4;
}

void opSLT(void)
{

if (regS[rs] < regS[rt] ) reg[rd]=1;
else reg[rd]=0;
rPC+=4;
}

void opXOR(void)
{
reg[rd]=reg[rt] ^ reg[rs];
rPC+=4;
}

void opXORI(void)
{
reg[rt]=reg[rs] ^ imedU;
rPC+=4;
}


		/* STORE INSTRUCTIONS */

void opSW(void)
{
if(!storeBufU(reg[rs]+imedS, reg[rt]))
 {
  incPC;
  return;
 }
else if(cpuError == CPU_EXECUTING_HARD)
 {
  hardAccess++;
  if (activeLog)
   fprintf(logHfile, "0x%08x  SW 0x%08x AT 0x%08x\n", rPC,reg[rt],reg[rs]+imedS);
  incPC;
  return;  
 }
else incPC;
}

void opSH(void)
{
if(!storeBufUW(reg[rs]+imedS, reg[rt]&0x0000ffff))
 {
  incPC;
  return;
 }
else if(cpuError == CPU_EXECUTING_HARD)
 {
  hardAccess++;
  if (activeLog)
   fprintf(logHfile, "0x%08x  SH 0x%08x AT 0x%08x\n", rPC,reg[rt],reg[rs]+imedS);
  incPC;
  return;  
 }
else incPC;
}


void opSB(void)
{
if(!storeBufUB(reg[rs]+imedS, reg[rt]&0x000000ff))
 {
  incPC;
  return;
 }
else if(cpuError == CPU_EXECUTING_HARD)
 {
  hardAccess++;
  if (activeLog)
   fprintf(logHfile, "0x%08x  SB 0x%08x AT 0x%08x\n", rPC,reg[rt],reg[rs]+imedS);
  incPC;
  return;  
 }
else incPC;
}


void opSWL(void)
{
 switch ((reg[rs]+imedS)&0x3)
  {
   case 3:
    if(!storeBufUB(reg[rs]+imedS, (reg[rt]>>24) & 0x000000ff))
     {
      storeBufUB(reg[rs]+imedS-1, (reg[rt]>>16) & 0x000000ff);
      storeBufUB(reg[rs]+imedS-2, (reg[rt]>>8) & 0x000000ff);
      incPC;
     }
    else
     cpuError = CPU_NOTIMPLEMENTED;
    return;
   default:
    cpuError = CPU_NOTIMPLEMENTED;
    return;
  }
}

void opSWR(void)
{
 switch ((reg[rs]+imedS)&0x3)
  {
   case 0:
    if(!storeBufUB(reg[rs]+imedS, reg[rt] & 0x000000ff))
     incPC;
    else
     cpuError = CPU_NOTIMPLEMENTED;
    return;
   default:
    cpuError = CPU_NOTIMPLEMENTED;
    return;
  }
}

void opLUI(void)
{
reg[rt]=buf << 16;
incPC;
}

void opLW(void)
{
if(!loadBufU(reg[rs]+imedS))
 {
  reg[rt]=buf;
  incPC;
  return;
 }
else if(cpuError == CPU_EXECUTING_HARD)
 {
  reg[rt]=buf;
  hardAccess++;
  if (activeLog)
   fprintf(logHfile, "0x%08x  LW 0x%08x AT 0x%08x\n", rPC,reg[rt],reg[rs]+imedS);
  incPC;
  return;  
 }
else incPC;
}

void opLWL(void)
{
 switch((reg[rs]+imedS)&0x3) // only the byte portion
  {
   case 0:
    if(!loadBufU((reg[rs]+imedS) & 0xfffffffc))
     {
      reg[rt] = ((buf << 24) & 0xff000000) | ((buf << 8) & 0x00ff0000) | (reg[rt] & 0x0000ffff);
      incPC;
     }
    else
     cpuError = CPU_NOTIMPLEMENTED;
    return;

   case 1:
    if(!loadBufU((reg[rs]+imedS) & 0xfffffffc))
     {
//      reg[rt] = ((buf << 16) & 0xff000000) | (reg[rt] & 0x00ffffff);
      reg[rt] = ((buf << 16) & 0xff000000) | (buf & 0x00ff0000) |(reg[rt] & 0x0000ffff);
      incPC;
     }
    else
     cpuError = CPU_NOTIMPLEMENTED;
    return;

   case 3:
    if(!loadBufU((reg[rs]+imedS) & 0xfffffffc))
     {
      reg[rt] = ((buf ) & 0xff000000) | (reg[rt] & 0x00ffffff);
      incPC;
     }
    else
     cpuError = CPU_NOTIMPLEMENTED;
    return;

   default:
    cpuError = CPU_NOTIMPLEMENTED;
    return;
  }
}

void opLWR(void)
{
 switch((reg[rs]+imedS)&0x3) // only the byte portion
  {
   case 0:
    if(!loadBufU((reg[rs]+imedS)&0xfffffffc))
     {
      reg[rt] = ((buf) & 0x00ffffff) | (reg[rt] & 0xff000000);
      incPC;
     }
    else
     cpuError = CPU_NOTIMPLEMENTED;
    return;

   case 2:
    if(!loadBufU((reg[rs]+imedS)&0xfffffffc))
     {
      reg[rt] = ((buf >> 16) & 0x000000ff) | ((buf>>16) & 0x0000ff00) | (reg[rt] & 0xffff0000);
      incPC;
     }
    else
     cpuError = CPU_NOTIMPLEMENTED;
    return;


   default:
    cpuError = CPU_NOTIMPLEMENTED;
    return;
  }
}


void opLHU(void)
{
if(!loadBufUW(reg[rs]+imedS))
 {
  reg[rt]=buf & 0x0000ffff;
  incPC;
  return;
 }
else if(cpuError == CPU_EXECUTING_HARD)
 {
  reg[rt]=buf & 0x0000ffff;
  hardAccess++;
  if (activeLog)
   fprintf(logHfile, "0x%08x  LH 0x%08x AT 0x%08x\n", rPC, reg[rt], reg[rs]+imedS);
  incPC;
  return;  
 }
else incPC;
}

void opLH(void)
{
if(!loadBufUW(reg[rs]+imedS))
 {
  reg[rt]=buf & 0x0000ffff;
  if (reg[rt] > 0x7fff) reg[rt]|=0xffff0000;
  incPC;
  return;
 }
else if(cpuError == CPU_EXECUTING_HARD)
 {
  reg[rt]=buf & 0x0000ffff;
  if (reg[rt] > 0x7fff) reg[rt]|=0xffff0000;
  hardAccess++;
  if (activeLog)
   fprintf(logHfile, "0x%08x  LH 0x%08x AT 0x%08x\n", rPC, reg[rt], reg[rs]+imedS);
  incPC;
  return;  
 }
else incPC;
}

void opLBU(void)
{
if(!loadBufUB(reg[rs]+imedS))
 {
  reg[rt]=buf & 0x000000ff;
  incPC;
  return;
 }
else if(cpuError == CPU_EXECUTING_HARD)
 {
  reg[rt]=buf & 0x000000ff;
  hardAccess++;
  if (activeLog)
   fprintf(logHfile, "0x%08x  LB 0x%08x AT 0x%08x\n", rPC,reg[rt],reg[rs]+imedS);
  incPC;
  return;  
 }
else incPC;
}

void opLB(void)
{
if(!loadBufUB(reg[rs]+imedS))
 {
  reg[rt]=buf & 0x000000ff;
  if (reg[rt] > 0x7f) reg[rt]|=0xffffff00;
  incPC;
  return;
 }
else if(cpuError == CPU_EXECUTING_HARD)
 {
  reg[rt]=buf & 0x000000ff;
  if (reg[rt] > 0x7f) reg[rt]|=0xffffff00;
  hardAccess++;
  if (activeLog)
   fprintf(logHfile, "0x%08x  LB 0x%08x AT 0x%08x\n", rPC,reg[rt],reg[rs]+imedS);
  incPC;
  return;  
 }
else incPC;
}


		/* BRANCH & JUMP INSTRUCTIONS */

void opJ(void)
{
unsigned long newPC;
newPC = ((buf & 0x03ffffff )<< 2)|(rPC & 0xf0000000);
incPC;
doInstr();
rPC=newPC;
}

void opJR(void)
{
 unsigned long newPC;
 newPC = reg[rs];
 incPC;
 doInstr();
 rPC=newPC;

 if (newPC == 0xa0)
  {
   romAF[reg[9]]();
   return;
  }
 else
  if (newPC == 0xb0)
  {
   romBF[reg[9]]();
   return;
  }
 else
  if (newPC == 0xc0)
  {
   romCF[reg[9]]();
   return;
  }
}

void opJAL(void)
{
unsigned long newPC;

newPC = ((buf & 0x03ffffff )<< 2)|(rPC & 0xf0000000);
incPC;
doInstr();
reg[31] = rPC;
rPC=newPC;
}

void opJALR(void)
{
 unsigned long newPC;
 newPC = reg[rs];
 incPC;
 doInstr();
 reg[31] = rPC;
 rPC=newPC;

 if (newPC == 0xa0)
  {
   romAF[reg[9]]();
   return;
  }
 else
  if (newPC == 0xb0)
  {
   romBF[reg[9]]();
   return;
  }
 else
  if (newPC == 0xc0)
  {
   romCF[reg[9]]();
   return;
  }
}

void opBNE(void)
{
 newPC = getBaddr(rPC);
 rPC+=4;
 if (reg[rt]!=reg[rs])
 {
  doInstr();
  rPC=newPC;
 }
}

void opBEQ(void)
{
 newPC = getBaddr(rPC);
 rPC+=4;
 if (reg[rt]==reg[rs])
 {
  doInstr();
  rPC=newPC;
 }
}

void opBLEZ(void)
{
 newPC = getBaddr(rPC);
 incPC;
 if (regS[rs]<=0)
 {
  doInstr();
  rPC=newPC;
 }
}
void opBLTZ(void)
{
 newPC = getBaddr(rPC);
 incPC;
 if (regS[rs]<0)
 {
  doInstr();
  rPC=newPC;
 }
}

void opBGTZ(void)
{
 newPC = getBaddr(rPC);
 incPC;
 if (regS[rs]>0)
 {
  doInstr();
  rPC=newPC;
 }
}

void opBGEZ(void)

{
 newPC = getBaddr(rPC);
 incPC;
 if (regS[rs]>=0)
 {
  doInstr();
  rPC=newPC;
 }
}

/* SPECIAL INSTRUCTIONS */

void opSLLV(void)
{
reg[rd]=reg[rt] << (reg[rs] & 0x1f);
rPC+=4;
}

void opSRAV(void)
{
regS[rd]=regS[rt] >> (regS[rs] & 0x1f);
rPC+=4;
}

void opSRLV(void)
{
reg[rd]=reg[rt] >> (reg[rs] & 0x1f);
rPC+=4;
}

void opSLL(void)
{
sa = (buf >> 6) & 0x1f;
reg[rd]=reg[rt] << sa;
rPC+=4;
}

void opSRL(void)
{
sa = (buf >> 6) & 0x1f;
reg[rd]=reg[rt] >> sa;
rPC+=4;
}

void opSRA(void)
{
sa = (buf >> 6) & 0x1f;
regS[rd]=regS[rt] >> sa;
incPC;
}

void opSYSCALL(void)
{
 if (activeLog)
  fprintf(logfile,"SYSCALL at %08x with %d\n",rPC,reg[4]);
 regCOP0[14]=rPC;
 regCOP0[13]=0x00000020;
 rPC=0x80;
}

void opBREAK(void)
{
 cpuError=CPU_DONE;
}
void opCOP0(void)
{
 if (rs == 4) // MTC
 {
  regCOP0[rd]=reg[rt];
  if (rd == 12 && (reg[rt]&2))
   {
    regCOP0[rd]=reg[rt] & 0xfffffffd;
    interEnable = 1;
   }    
  incPC;
  return;
 }
 if (rs == 0) // MFC
 {
  reg[rt]=regCOP0[rd];
  incPC;
  return;
 }
 
}

void opCOP2(void)
{
 if (rs == 6) // CTC
 {
  regCOP2[rd]=reg[rt];
  fprintf(outfile,"!GTE! reg[%02x] = %08x\n",rd,reg[rt]);
  incPC;
  return;
 }
}
void opMFHI(void)
{
 regS[rd] = regHI;
 incPC;
}

void opMFLO(void)
{
 regS[rd] = regLO;
 incPC;
}

void opMTHI(void)
{
 regHI=regS[rs];
 incPC;
}

void opMTLO(void)
{
 regLO=regS[rs];
 incPC;
}

void opDIV(void)
{
 regLO = regS[rs]/regS[rt];
 regHI = regS[rs]%regS[rt];
 incPC;
}

void opDIVU(void)
{
 regLO = reg[rs]/reg[rt];
 regHI = reg[rs]%reg[rt];
 incPC;
}
void opMULT(void)
{
 long v1,v2;
 unsigned long a,b,c,d,bd,ad,cb,ac;
 unsigned long mid,mid2;
 unsigned long carry_mid = 0;
 int neg_sign = 0;
 v1 = regS[rs];
 v2 = regS[rt];
 if (v1<0)
  {
   v1 = -v1;
   neg_sign = 1;
  }
 if (v2<0)
  {
   v2 = -v2;
   neg_sign = ! neg_sign;
  }
 a = (v1>>16) & 0xffff;
 b = v1 & 0xffff;
 c = (v2>>16) & 0xffff;
 d = v2 & 0xffff;
 bd = b*d;
 ad = a*d;
 cb = c*b;
 ac = a*c;
 mid = ad+cb;
 if(mid<ad || mid<cb) carry_mid = 1;
 mid2 = mid +((bd>>16)&0xffff);
 if (mid2<mid || mid2 < ((bd>>16)&0xffff)) carry_mid +=1;
 regLO = (bd & 0xffff) | ((mid2 & 0xffff) << 16);
 regHI = ac + (carry_mid<<16) + ((mid2 >> 16) &  0xffff);
 if (neg_sign)
  {
   regLO = ~regLO;
   regHI = ~regHI;
   regLO +=1;
   if (regLO == 0) regHI+=1;
  }
 incPC;
}


void opMULTU(void)
{
 long v1,v2;
 unsigned long a,b,c,d,bd,ad,cb,ac;
 unsigned long mid,mid2,carry_mid = 0;
 v1 = reg[rs];
 v2 = reg[rt];
 a = (v1>>16) & 0xffff;
 b = v1 & 0xffff;
 c = (v2>>16) & 0xffff;
 d = v2 & 0xffff;
 bd = b*d;
 ad = a*d;
 cb = c*b;
 ac = a*c;
 mid = ad+cb;
 if(mid<ad || mid<cb) carry_mid = 1;
 mid2 = mid +((bd>>16)&0xffff);
 if (mid2<mid || mid2 < ((bd>>16)&0xffff)) carry_mid +=1;
 regLO = (bd & 0xffff) | ((mid2 & 0xffff) << 16);
 regHI = ac + (carry_mid<<16) + ((mid2 >> 16) &  0xffff);

 incPC;
}

